#pragma once
#include <jni.h>

#include <map>
#include <string>

#include "event.h"

//fwd declr
class CppPlugin;

//function pointer
typedef void (*eventfptr)(JNIEnv*, CppPlugin*, Event*);
typedef CppPlugin* (*initfptr)();

class CppPlugin {
public:
	void* handle;
	std::string name;
	virtual void onLoad();
	virtual void onEnable();
	virtual void onDisable();
	virtual std::map<std::string, eventfptr> getEvents();
	virtual ~CppPlugin();
};

